pcl::PPFHashMapSearch Class Reference

`#include <pcl/registration/ppf_registration.h>`

## Classes

struct | HashKeyStruct
| Data structure to hold the information for the key in the feature hash map of the PPFHashMapSearch class. More...

## Public Types

typedef boost::unordered_multimap< HashKeyStruct, std::pair< size_t, size_t > > | FeatureHashMapType
typedef boost::shared_ptr< FeatureHashMapType > | FeatureHashMapTypePtr
typedef boost::shared_ptr< PPFHashMapSearch > | Ptr

## Public Member Functions

| PPFHashMapSearch (float angle_discretization_step=12.0f/180.0f *static_cast< float >(M_PI), float distance_discretization_step=0.01f)
| Constructor for the PPFHashMapSearch class which sets the two step parameters for the enclosed data structure. More...
void | setInputFeatureCloud (PointCloud< PPFSignature >::ConstPtr feature_cloud)
| Method that sets the feature cloud to be inserted in the hash map. More...
void | nearestNeighborSearch (float &f1, float &f2, float &f3, float &f4, std::vector< std::pair< size_t, size_t > > &indices)
| Function for finding the nearest neighbors for the given feature inside the discretized hash map. More...
Ptr | makeShared ()
| Convenience method for returning a copy of the class instance as a boost::shared_ptr. More...
float | getAngleDiscretizationStep ()
| Returns the angle discretization step parameter (the step value between each bin of the hash map for the angular values) More...
float | getDistanceDiscretizationStep ()
| Returns the distance discretization step parameter (the step value between each bin of the hash map for the distance values) More...
float | getModelDiameter ()
| Returns the maximum distance found between any feature pair in the given input feature cloud. More...

## Public Attributes

std::vector< std::vector< float > > | alpha_m_

## Detailed Description

Definition at line 51 of file ppf_registration.h.

## Member Typedef Documentation

## FeatureHashMapType

typedef boost::unordered_multimap<HashKeyStruct, std::pair<size_t, size_t> > pcl::PPFHashMapSearch::FeatureHashMapType

Definition at line 69 of file ppf_registration.h.

## FeatureHashMapTypePtr

typedef boost::shared_ptr<FeatureHashMapType> pcl::PPFHashMapSearch::FeatureHashMapTypePtr

Definition at line 70 of file ppf_registration.h.

## Ptr

typedef boost::shared_ptr<PPFHashMapSearch> pcl::PPFHashMapSearch::Ptr

Definition at line 71 of file ppf_registration.h.

## Constructor & Destructor Documentation

## PPFHashMapSearch()

pcl::PPFHashMapSearch::PPFHashMapSearch | ( | float | angle_discretization_step = `12.0f / 180.0f * static_cast<float> (M_PI)`,
|  | float | distance_discretization_step = `0.01f`
| ) |  |

inline

Constructor for the PPFHashMapSearch class which sets the two step parameters for the enclosed data structure.

Parameters

  angle_discretization_step | the step value between each bin of the hash map for the angular values
  distance_discretization_step | the step value between each bin of the hash map for the distance values

Definition at line 78 of file ppf_registration.h.

## Member Function Documentation

## getAngleDiscretizationStep()

float pcl::PPFHashMapSearch::getAngleDiscretizationStep | ( |  | ) |

inline

Returns the angle discretization step parameter (the step value between each bin of the hash map for the angular values)

Definition at line 113 of file ppf_registration.h.

## getDistanceDiscretizationStep()

float pcl::PPFHashMapSearch::getDistanceDiscretizationStep | ( |  | ) |

inline

Returns the distance discretization step parameter (the step value between each bin of the hash map for the distance values)

Definition at line 117 of file ppf_registration.h.

## getModelDiameter()

float pcl::PPFHashMapSearch::getModelDiameter | ( |  | ) |

inline

Returns the maximum distance found between any feature pair in the given input feature cloud.

Definition at line 121 of file ppf_registration.h.

## makeShared()

Ptr pcl::PPFHashMapSearch::makeShared | ( |  | ) |

inline

Convenience method for returning a copy of the class instance as a boost::shared_ptr.

Definition at line 109 of file ppf_registration.h.

## nearestNeighborSearch()

void pcl::PPFHashMapSearch::nearestNeighborSearch | ( | float & | f1,
|  | float & | f2,
|  | float & | f3,
|  | float & | f4,
|  | std::vector< std::pair< size_t, size_t > > & | indices
| ) |  |

Function for finding the nearest neighbors for the given feature inside the discretized hash map.

Parameters

  f1 | The 1st value describing the query PPFSignature feature
  f2 | The 2nd value describing the query PPFSignature feature
  f3 | The 3rd value describing the query PPFSignature feature
  f4 | The 4th value describing the query PPFSignature feature
  indices | a vector of pair indices representing the feature pairs that have been found in the bin corresponding to the query feature

## setInputFeatureCloud()

void pcl::PPFHashMapSearch::setInputFeatureCloud | ( | PointCloud< PPFSignature >::ConstPtr | feature_cloud | ) |

Method that sets the feature cloud to be inserted in the hash map.

Parameters

  feature_cloud | a const smart pointer to the PPFSignature feature cloud

## Member Data Documentation

## alpha_m_

std::vector<std::vector <float> > pcl::PPFHashMapSearch::alpha_m_

Definition at line 123 of file ppf_registration.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/registration/include/pcl/registration/ppf_registration.h